# This file was auto-generated by Fern from our API Definition.

from backports.cached_property import cached_property

from .environment import CodeCombatEnvironment
from .resources.auth.client import AsyncAuthClient, AuthClient
from .resources.clans.client import AsyncClansClient, ClansClient
from .resources.classrooms.client import AsyncClassroomsClient, ClassroomsClient
from .resources.stats.client import AsyncStatsClient, StatsClient
from .resources.users.client import AsyncUsersClient, UsersClient


class CodeCombat:
    def __init__(
        self, *, environment: CodeCombatEnvironment = CodeCombatEnvironment.PRODUCTION, username: str, password: str
    ):
        self._environment = environment
        self._username = username
        self._password = password

    @cached_property
    def auth(self) -> AuthClient:
        return AuthClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def clans(self) -> ClansClient:
        return ClansClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def classrooms(self) -> ClassroomsClient:
        return ClassroomsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def stats(self) -> StatsClient:
        return StatsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def users(self) -> UsersClient:
        return UsersClient(environment=self._environment, username=self._username, password=self._password)


class AsyncCodeCombat:
    def __init__(
        self, *, environment: CodeCombatEnvironment = CodeCombatEnvironment.PRODUCTION, username: str, password: str
    ):
        self._environment = environment
        self._username = username
        self._password = password

    @cached_property
    def auth(self) -> AsyncAuthClient:
        return AsyncAuthClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def clans(self) -> AsyncClansClient:
        return AsyncClansClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def classrooms(self) -> AsyncClassroomsClient:
        return AsyncClassroomsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def stats(self) -> AsyncStatsClient:
        return AsyncStatsClient(environment=self._environment, username=self._username, password=self._password)

    @cached_property
    def users(self) -> AsyncUsersClient:
        return AsyncUsersClient(environment=self._environment, username=self._username, password=self._password)
