# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from ...commons.types.object_id_string import ObjectIdString


class ClanResponse(pydantic.BaseModel):
    """
    Subset of properties listed here
    """

    id: typing.Optional[ObjectIdString] = pydantic.Field(alias="_id")
    name: typing.Optional[str]
    display_name: typing.Optional[str] = pydantic.Field(alias="displayName")
    members: typing.Optional[typing.List[ObjectIdString]]
    owner_id: typing.Optional[ObjectIdString] = pydantic.Field(alias="ownerID")
    description: typing.Optional[str]
    type: typing.Optional[str]
    kind: typing.Optional[str]
    metadata: typing.Optional[typing.Dict[str, typing.Any]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
